Subject: guix pull --roll-back breaks guix

From: Blake Shaw <[email-masked]>
Date: Wed, 05 Jul 2023 17:21:23 +0700

Hiya Guix,

I just encountered a surprising bug.

I've been trying to get the [redacted] proprietary GPU drivers to work on my system (but this isnt particular to the issue at hand), and I "guix installed" the [redacted-module] package in my .guix-profile, to see if that would help me with the failed

$ modprobe [redacted] 

that I was experiencing.

It didn't, so I decided to do what we do best: roll-back. But I accidentally ran

$ guix pull --roll-back

instead of

$ guix package --roll-back

This mistake should be trivial, fixable by running

$ guix pull --switch-generation=N

Where N is the "FROM" field of the roll-back message that guix displays following a successfull roll back.

But to my surprise an anomaly appeared in the "TO" field of the roll-back message:

$ guix pull --roll-back
building path(s) `/gnu/store/2s7a7h...gj23-profile`
switched from generation 86 to 0

Huh? Zero? It should have switched to 85. Weird, but np, let's just direct it to 85.

$ guix pull --switch-generation=85
-bash: /home/my-profile/.config/guix/current/bin/guix

So now it can't find guix. Visiting .config/guix/current/ it is empty except an etc dir and a manifest. so I use guix from the run directory to get back on track:

$ exec /run/current-system/profile/bin/guix --switch-generation=85
guix pull error: cannot switch to generation '85'

$ exec /run/current-system/profile/bin/guix --switch-generation=86
switched from generation 0 to 86

And then $HOME/.config/guix/current is back to normal and everything works fine. So I assume this was due to yesterday's guix gc --delete-generations=1d 

But like, should this happen? Should we ever be rolling back to an empty "0" generation that doesn't even contain guix, and thus creates a pickle for those who don't have prior knowledge of how to get out of it? Should we limit gc --delete-generations to always keep a previous generation at hand, perhaps unless forced by some other flag, so that [in particular, new] users don't break their systems in the middle of the day and then have something to solve that encumbers their plans & work?

Happy hacking!
Blake